import static org.junit.jupiter.api.Assertions.*;

import java.util.ArrayList;

import org.junit.jupiter.api.Test;

import junit.framework.Assert;

class Jtest {

	@Test
	void testOrder() 
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		assertEquals(1,order.getOrderTS());
		assertEquals(100,order.getCustID());
		assertEquals("Apple",order.getStockName());
		assertEquals("Buy",order.getTradeType());
		assertEquals(70,order.getPrice());
		assertEquals(100,order.getQuantity());
		
	}
	@Test
	void testSetPrice()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		order.setPrice(20);
		assertEquals(20,order.getPrice());
		
	}
	@Test
	void testSetQuant()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		order.setQuantity(30);
		assertEquals(30,order.getQuantity());
		
	}
	@Test
	void testGetQuant()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		
		assertEquals(100,order.getQuantity());
		
	}@Test
	void testGetPrice()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		assertEquals(70,order.getPrice());
		
	}@Test
	void testGetStockName()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		assertEquals("Apple",order.getStockName());
		
	}@Test
	void testGetType()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		assertEquals("Buy",order.getTradeType());
		
	}
	@Test
	void testToString()
	{
		Order order = new Order(1,100,"Apple","Buy",70,100);
		assertEquals(1+","+100+","+"Apple"+","+"Buy,"+70+","+100,order.toString());
		
		
	}
	@Test
	void testViewList() 
	{
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		market.AddOrder(1,100,"Apple","Buy",70,100);
		market.AddOrder(2,101,"Apple","Buy",170,200);
		assertEquals("1,100,Apple,Buy,70,100\n"+"2,101,Apple,Buy,170,200",market.ViewList());
		
		
	}
	@Test
	void testAddOrder() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		market.AddOrder(1,100,"Apple","Buy",70,100);
		market.AddOrder(2,101,"Apple","Buy",170,200);
		assertEquals("1,100,Apple,Buy,70,100\n"+"2,101,Apple,Buy,170,200",market.ViewList());
		
		
		
	}
	@Test
	void testAddOrder2() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		assertEquals(false,market.AddOrder(1,100,"Apple","buy",70,100));
		assertEquals(true,market.AddOrder(2,101,"Apple","sell",70,20));
		
		
		
	}
	@Test
	void testAddOrder3() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		assertEquals(false,market.AddOrder(1,100,"Apple","buy",70,100));
		assertEquals(false,market.AddOrder(2,101,"Apple","buy",70,20));
		assertEquals(true,market.AddOrder(3,104,"Apple","sell",70,120));
		
		
		
	}
	@Test
	void testAddOrder4() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		assertEquals(false,market.AddOrder(1,100,"Apple","buy",70,100));
		assertEquals(false,market.AddOrder(2,100,"Apple","buy",70,20));
		assertEquals(false,market.AddOrder(3,104,"Baidu","sell",70,120));
		assertEquals(false,market.AddOrder(4,105,"Baidu","buy",80,130));
		
		
		
	}
	@Test
	void testAddOrder5() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		assertEquals(false,market.AddOrder(1,100,"Apple","sell",70,100));
		assertEquals(false,market.AddOrder(2,100,"Apple","sell",80,20));
		assertEquals(true,market.AddOrder(3,104,"Apple","buy",90,120));
		
		
		
	}

	@Test
	void testAddOrder6() 
	{
		
		StockMarket market=new StockMarket();
		market.pending_list = new ArrayList<Order>();
		assertEquals(false,market.AddOrder(1,100,"Apple","sell",70,100));
		assertEquals(false,market.AddOrder(2,100,"Apple","sell",80,20));
		assertEquals(false,market.AddOrder(3,104,"Apple","buy",90,140));
		
		
		
	}
}
